package se.chalmers.cs.gf.abssyn;

/**
 *  Visitor interface for visiting untyped abstract syntax trees.
 *
 *  @param <R> The return type of the visitor.
 *  @param <A> The type of the data argument.
 */
public interface TreeVisitor<R,A> {

        public R visit(Fun f, A arg);
        public R visit(IntLiteral l, A arg);
        public R visit(StringLiteral l, A arg);
        public R visit(MetaVariable v, A arg);

}
