package se.chalmers.cs.gf.parse;

import java.util.logging.*;

/**
 *  Handles logging for the parsing package.
 */
public class ParseLogger {

        private static Logger logger = Logger.getLogger("se.chalmers.cs.gf.parse");

        private ParseLogger() {}

        public static void fine(String s) {
                log(Level.FINE, s);
        }

        public static void finer(String s) {
                log(Level.FINER, s);
        }

        public static void finest(String s) {
                log(Level.FINEST, s);
        }

        public static void error(Throwable t) {
                LogRecord r = new LogRecord(Level.SEVERE, "Throw");
                r.setThrown(t);
                logger.log(r);
        }

        private static void log(Level l, String s) {
                logger.log(l, s);
        }

}
