package se.chalmers.cs.gf.parse.chart;

import se.chalmers.cs.gf.parse.Parsers;

import java.io.*;

/**
 *  A collection of chart parsers for a collection of CF grammars.
 */
public class CFGParsers extends Parsers {

        public CFGParsers(CFGGrammars grammars) {
                for (String n : grammars.listGrammars()) {
//                        System.err.println("Loading cfg grammar " + n);
                        CFGrammar g = grammars.getGrammar(n);
                        ChartParser p = new ChartParser(g);
                        addParser(p);
                }
        }

        public static CFGParsers readParsers(Reader in) throws IOException {
                return new CFGParsers(CFGGrammars.readCFGM(in));
        }

        public static CFGParsers readParsers(String file) throws IOException {
                return new CFGParsers(CFGGrammars.readCFGM(file));
        }

}
