package se.chalmers.cs.gf.parse.chart;

/**
 *  A CF grammar category.
 */
public class Category extends Symbol implements Comparable<Category> {

        private String name;

        public Category(String name) {
                this.name = name;
        }

        public String getName() {
                return name;
        }

        public boolean isTerminal() {
                return false;
        }

        public boolean equals(Object o) {
                return o instanceof Category && equals((Category)o);
        }

        public boolean equals(Category c) {
                return name.equals(c.name);
        }

        public int compareTo(Category c) {
                return name.compareTo(c.name);
        }

        public int hashCode() {
                return name.hashCode();
        }

        public String toString() {
                return name;
        }

}
