package se.chalmers.cs.gf.parse.chart;

import java.util.*;
import java.util.regex.*;

/**
 *  A simple lexer.
 */
public class Lexer {

        private Pattern tokenPatt;

        public Lexer() {
                // simple words are any non-empty sequence of 
                // upper case letters, lower case letters
                // and decimal digits
                String word = "[\\p{Lu}\\p{Ll}\\p{Nd}]+";
                // quoted words are strings of any character non double quote
                // enclosed in double quotes
                // FIXME: allow escaped double quotes and backslashes
                String quoted = "\"[^\"]*\"";
                // punctuation is a non-empty string of punctuation characters
                String punct = "[\\.\\,\\?\\!\\(\\)\\:\\;\\-\\[\\]\\{\\}&\\$]+";
                tokenPatt = Pattern.compile("(" + word 
                                            + "|" + quoted 
                                            + "|" + punct 
                                            + ")");
        }

        // FIXME: discards input that it doesn't understand
        public List<Token> lex(CharSequence input) {
                List<Token> ts = new ArrayList<Token>();

                Matcher m = tokenPatt.matcher(input);
                while (m.find()) {
                        String s = m.group();
                        ts.add(new Token(s));
                }

                return ts;
        }

/*
        public static void main(String[] args) throws java.io.IOException {
                Lexer l = new Lexer();
                java.io.BufferedReader in = new java.io.BufferedReader(new java.io.InputStreamReader(System.in));
                String line;
                while ((line = in.readLine()) != null)
                        System.out.println(l.lex(line));
        }
*/

}
