package se.chalmers.cs.gf.parse.chart;

import se.chalmers.cs.gf.abssyn.*;

import java.util.*;

public class StringLiteralRule extends TerminalRule {

        private Set<String> knownWords;

        public StringLiteralRule(Set<String> knownWords) {
                super("String", new Category("String{}.s"), new Terminal("<string literal>"));

                this.knownWords = knownWords;
        }

        public boolean matches(Token token) {
                if (!token.isString())
                        return false;

                // unquoted known words are not literals
                if (knownWords.contains(token.getValue()))
                        return false;

                return true;
        }

        public Tree makeTree(Token t) {
                if (t.isQuoted())
                        return new StringLiteral(t.unquotedValue());
                else
                        return new StringLiteral(t.getValue());
        }

}
