package se.chalmers.cs.gf.parse.chart;

/**
 *  A CF grammar terminal.
 */
public class Terminal extends Symbol {

        private String tok;

        public Terminal(String tok) {
                this.tok = tok;
        }

        public String getToken() {
                return tok;
        }

        public boolean isTerminal() {
                return true;
        }

        public boolean matches(Token t) {
                return tok.equals(t.getValue());
        }

        public boolean equals(Object o) {
                return o instanceof Terminal && equals((Terminal)o);
        }

        public boolean equals(Terminal t) {
                return tok.equals(t.tok);
        }

        public int hashCode() {
                return tok.hashCode();
        }

        public String toString() {
                return '"' + tok + '"';
        }

}
