package se.chalmers.cs.gf.parse.chart;

import java.util.*;

public class TerminalEdge extends Edge {

        private TerminalRule rule;

        private Token token;

        public TerminalEdge(TerminalRule rule, Token token) {
                this.rule = rule;
                this.token = token;
        }

        /**
         *  Get the rule that this edge is for.
         */
        public TerminalRule getRule() {
                return rule;
        }

        /**
         *  Get the input token that this terminal edge covers.
         */
        public Token getToken() {
                return token;
        }

        /**
         *  Checks if the next symbol needed is the given category.
         */
        public boolean needs(Category c) {
                return false;
        }

        /**
         *  Checks if this edge is active, that is, if it is still missing 
         *  some symbol.
         */
        public boolean isActive() {
                return false;
        }
        
        public boolean equals(Object o) {
                return o instanceof TerminalEdge && equals((TerminalEdge)o);
        }

        public boolean equals(TerminalEdge e) {
                return rule.equals(e.rule) && token.equals(token);
        }

        public int hashCode() {
                return rule.hashCode() + token.hashCode();
        }

        public String toString() {
                StringBuilder sb = new StringBuilder();
                sb.append(rule);
                sb.append(" '").append(token).append("'");
                return sb.toString();
        }

}
