package se.chalmers.cs.gf.translate;

import se.chalmers.cs.gf.GFException;

import java.util.*;

/**
 *  A collection of translators.
 */
public class Translators {

        private Map<String,Translator> translators;

        public Translators() {
                this.translators = new HashMap<String,Translator>();
        }

        /**
         *  @return The translator with the given name, or null if there 
         *  is no such translator.
         */
        public Translator getTranslator(String name) {
                return translators.get(name);
        }

        public void addTranslator(Translator t) {
                translators.put(t.getName(), t);
        }

        /**
         *  Get the names of all the available translators.
         */
        public List<String> listTranslators() {
                return new ArrayList<String>(translators.keySet());
        }

}
