package se.chalmers.cs.gf.util;

import java.util.*;

/**
 *  Maps keys to sets of values.
 *  @param <K> The type of the keys
 *  @param <V> The type of the values.
 */
public class MultiMap<K,V> {

        private Map<K,Set<V>> map;

        public MultiMap() {
                this.map = new HashMap<K,Set<V>>();
        }

        public Set<V> get(K key) {
                Set<V> s = map.get(key);
                return s == null ? Collections.<V>emptySet() : s;
        }

        public void put(K key, V value) {
                Set<V> s = map.get(key);
                if (s == null) {
                        s = new HashSet<V>();
                        map.put(key, s);
                }
                s.add(value);
        }

        public String toString() {
                return map.toString();
        }

}
